(function () {

	var scriptLoaded = false;

	function loadScriptList(scriptList) {
		var oHead = document.head || document.getElementsByTagName("head")[0];

		var randomizer = Math.random().toString(10).substring(2, 8);

		return new Promise(function(resolve, reject) {
			var onAfterLoadSingle = _.after(scriptList.length, resolve);
			_.each(scriptList, loadSingleScript);

			function loadSingleScript(script) {
				var sc = document.createElement('script');

				sc.onload = onAfterLoadSingle;
				sc.onerror = reject;

				sc.setAttribute('type','text/javascript');
				sc.setAttribute('src', script + '?rnd=' + randomizer);

				oHead.appendChild(sc);
			}
		});
	}

	function loadFrame() {
		scriptLoaded = true;
		application.run(4); // version ?
	}

	function onDeviceReady() {
		// если соединения нет никакого, то об этом говорим сразу
		if (navigator.connection && navigator.connection.type === 'none') {
			showConnectionErrorMessage(0);
			location.reload();
			return;
		}

		// праячем status bar
		AndroidFullScreen.immersiveMode(function() {
			console.log('Immersive mode enabled');
		}, function(err){
			console.log(err);
		});

		// даем 20 сек. на загрузку стартовых скриптов
		scriptLoaded = false;
		setTimeout(function () {
			if (!scriptLoaded) {
				showConnectionErrorMessage(1);
				location.reload();
			}
		}, 20000);

		loadScriptList(scriptList)
			.then(loadFrame)
			.catch(function (error) {
				if (error && error.stack) {
					window.fabric.Crashlytics.setStringValueForKey(error.stack, 'stack');
				}
				window.fabric.Crashlytics.sendNonFatalCrash(error.message);

				showConnectionErrorMessage(2);

				location.reload();
			});
	}

	function showConnectionErrorMessage(step) {
		navigator.globalization.getLocaleName(function (data) {
			var locale = data.value.split('-')[0];
			showMessageForLocale(step, locale);
		}, function () {
			showMessageForLocale(step);
		});

		function showMessageForLocale(step, locale) {
			if (!connectionErrorText[locale]) {
				locale = 'en';
			}

			var msg = (errorCodes[locale][step] ? errorCodes[locale][step] : '') + ' ' +connectionErrorText[locale];
			alert(msg);
		}
	}

	var connectionErrorText = {
		ru: 'Невозможно запустить приложение, проверьте подключение к интернету!',
		en: 'Unable to start the application, check the the Internet connection!',
		jp: 'アプリケーションを起動することができません、インターネット接続を確認！'
	};

	var errorCodes = {
		ru: ['Синий кекс плачет.', 'Леденцы грустят.', 'Шоколадка огорчена.'],
		en: ['Blue Muffin is crying.', 'Lollipops are sad.', 'Chocolate is upset.'],
		jp: ['ブルーマフィンが泣いてるよ。', 'ロリポップも悲しがってる。', 'チョコレートはムスッとしてるよ。']
	};

	document.addEventListener("deviceready", onDeviceReady, false);
})();